﻿namespace IntersectDataTables
{
    using System.Data;
    using System.Linq;
    using System.Windows.Forms;

    public partial class Form1 : Form
    {
        public Form1()
        {
            this.InitializeComponent();

            DataTable table1 = this.GetTableData(1, 4);
            DataTable table2 = this.GetTableData(5, 6);

            this.Grid1.DataSource = table1;
            this.Grid2.DataSource = table2;

            DataTable resultTable = table1.AsEnumerable()
                      .Where(id1 => !table2.AsEnumerable()
                      .Any(id2 => id2.Field<int>("Id") == id1.Field<int>("Id")))
                      .CopyToDataTable();

            this.ResultGrid.DataSource = resultTable;
        }

        private DataTable GetTableData(int start, int end)
        {
            DataTable dt = new DataTable();
            dt.Columns.Add("Id", typeof(int));
            dt.Columns.Add("name", typeof(string));

            for (int row = 0; row <= end - start; row++)
            {
                dt.Rows.Add(new object[] { row + 1, "data" + (start + row) });
            }

            return dt;
        }
    }
}
